!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCEnumPrn.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER
 MAP
 END

 INCLUDE('CFCEnumPrn.inc'),ONCE

_Shell32Library_             LONG
_SHInvokePrinterCommand_     LONG,STATIC,NAME('CFC_SHInvokePrinterCommand')



CFCEnumPrinters.Construct             PROCEDURE()
cstrShell32Name     CSTRING('shell32.dll')
cstrProcName        CSTRING('SHInvokePrinterCommandA')
 code
 SELF.QPrns &= NEW CFCTQ_Printers
 IF NOT _Shell32Library_
    _Shell32Library_ = CFC_LoadLibrary(cstrShell32Name)
    IF _Shell32Library_ !   
       _SHInvokePrinterCommand_ = CFC_GetProcAddress(_Shell32Library_,cstrProcName)
    END
 END

CFCEnumPrinters.Destruct              PROCEDURE()
 code
 if not SELF.QPrns &= NULL then dispose(SELF.QPrns).
 IF _Shell32Library_
    Err# = CFC_FreeLibrary(_Shell32Library_)
 END

CFCEnumPrinters.Enum                  PROCEDURE()
loc:Buf                 &STRING
loc:Needed              LONG
loc:Items               LONG
loc:PRINTER_INFO        LIKE(CFC_PRINTER_INFO_2)
loc:cstrName            CSTRING(256)
loc:BufSize             LONG
loc:RetValue            LONG
 code
 loc:RetValue = 0         !    
 free(SELF.QPrns)
 loc:Buf &= NEW STRING(1) !    ,  
 if NOT CFC_EnumPrinters(CFC_PRINTER_ENUM_LOCAL+CFC_PRINTER_ENUM_CONNECTIONS,0,2,address(loc:Buf),size(loc:Buf),address(loc:Needed),address(loc:Items))
    if CFC_GetLastError() = CFC_ERROR_INSUFFICIENT_BUFFER !  
       if not loc:Buf &= NULL
          dispose(loc:Buf)                                !  
          loc:Buf &= NEW STRING(loc:Needed)               !      
          if CFC_EnumPrinters(CFC_PRINTER_ENUM_LOCAL+CFC_PRINTER_ENUM_CONNECTIONS,0,2,address(loc:Buf),size(loc:Buf),address(loc:Needed),address(loc:Items))
              loc:RetValue = loc:Items
              loc:BufSize = loc:Items*size(CFC_PRINTER_INFO_2)
              loop addr# = 0 to loc:BufSize - size(CFC_PRINTER_INFO_2) by size(CFC_PRINTER_INFO_2)
                  CFC_memcpy(address(loc:PRINTER_INFO),address(loc:Buf) + addr#,size(CFC_PRINTER_INFO_2))
                  clear(SELF.QPrns)
                  loc:cstrName = '' !  
                  CFC_memcpy(address(loc:cstrName),loc:PRINTER_INFO.pPrinterName,256)
                  SELF.QPrns.PrinterName = loc:cstrName

                  loc:cstrName = '' ! 
                  CFC_memcpy(address(loc:cstrName),loc:PRINTER_INFO.pPortName,256)
                  SELF.QPrns.PortName = loc:cstrName

                  loc:cstrName = '' ! 
                  CFC_memcpy(address(loc:cstrName),loc:PRINTER_INFO.pDriverName,256)
                  SELF.QPrns.DriverName = loc:cstrName

                  loc:cstrName = '' ! 
                  CFC_memcpy(address(loc:cstrName),loc:PRINTER_INFO.pComment,256)
                  SELF.QPrns.Comment = loc:cstrName

                  !    
                  if PRINTER{PROPPRINT:Device} = clip(SELF.QPrns.PrinterName)
                     SELF.QPrns.FlagCurrent = TRUE
                     add(SELF.QPrns,1) !      
                  else
                     add(SELF.QPrns)
                  end
                  
              end
          end
       end
    end
 end
 if not loc:Buf &= NULL then dispose(loc:Buf).

 return loc:RetValue
CFCEnumPrinters.PrnProperties   PROCEDURE(LONG inhwnd,STRING inPrinterName)
OS_INFO             LIKE(CFC_OSVERSIONINFO)
cstrTmp             CSTRING(255)
cstrEmpty           CSTRING(10)
 CODE
 IF _SHInvokePrinterCommand_
    cstrTmp = clip(inPrinterName)
    cstrEmpty = ''
    clear(OS_INFO)
    OS_INFO.dwOSVersionInfoSize = SIZE(CFC_OSVERSIONINFO)
    IF CFC_GetVersionEx(address(OS_INFO)) !   
       IF OS_INFO.dwPlatformId = CFC_VER_PLATFORM_WIN32_NT
          CFC_SHInvokePrinterCommand(inhwnd,CFC_PRINTACTION_DOCUMENTDEFAULTS,address(cstrTmp),address(cstrEmpty),1)
       ELSE
          CFC_SHInvokePrinterCommand(inhwnd,CFC_PRINTACTION_PROPERTIES,address(cstrTmp),address(cstrEmpty),1)
       END
    ELSE
       CFC_SHInvokePrinterCommand(inhwnd,CFC_PRINTACTION_PROPERTIES,address(cstrTmp),address(cstrEmpty),1)
    END
 END



